#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <curses.h>

#define IDLE  0
#define NORTH 1
#define SOUTH 2
#define EAST  3
#define WEST  4

const int SCREEN_Y = 25;
const int SCREEN_X = 80;

const int nJoeys = 256;


struct Actor
    {
    int x, y;
    };

int move_actor( struct Actor *picked, int direction ) {
    int goX = 0;
    int goY = 0;
    switch( direction )
    {
        case IDLE:
        {
            goX = 0;
            goY = 0;
            break;
        }
        case NORTH:
        {
            goX = 0;
            goY = -1;
            break;
        }
        case SOUTH:
        {
            goX = 0;
            goY = 1;
            break;
        }
        case EAST:
        {
            goX = 1;
            goY = 0;
            break;
        }
        case WEST:
        {
            goX = -1;
            goY = 0;
            break;
        }
    }
    if( picked->x + goX >= 0 && picked->x + goX < SCREEN_X )
    {
        picked->x += goX;
    }
    if( picked->y + goY >= 0 && picked->y + goY < SCREEN_Y )
    {
        picked->y += goY;
    }
    return 0;
}


int main() {

    srand( time( NULL ) );

    if( nJoeys >= SCREEN_X * SCREEN_Y )
    {
        printf( "TOO MANY JOEYS!!!!!111" );
        return 1;
    }

    struct Actor *oldJoey = (struct Actor *) malloc( nJoeys * sizeof( struct Actor ) );
    int i, j;
    for( i = 0; i < nJoeys; i++ )
    {
        oldJoey[ i ].x = 0;
        oldJoey[ i ].y = 0;
    }

    int donePlacement = 0;
    while( donePlacement == 0 )
    {
        donePlacement = 1;
        if( nJoeys == 1 )
        {
            break;
        }

        for( i = 0; i < nJoeys; i++ )
        {
            for( j = 0; j < nJoeys; j++ )
            {
                //don't compare an old joey to itself
                if( i != j )
                {
                    if( ( oldJoey[ i ].x == oldJoey[ j ].x ) && ( oldJoey[ i ].y == oldJoey[ j ].y ) )
                    {
                        oldJoey[ j ].y = rand() % SCREEN_Y;
                        oldJoey[ j ].x = rand() % SCREEN_X;
                        donePlacement = 0;
                    }
                }
            }
        }
    }

    initscr();

    curs_set( 0 );

    keypad( stdscr, 1 );
    raw();
    nodelay( stdscr, 0 );
    noecho();
    nonl();

    int quit = 0;
    while( quit == 0 )
    {
        //draw, pilgrim
        erase();
        for( i = 0; i < nJoeys; i++ )
        {
            mvaddch( oldJoey[ i ].y, oldJoey[ i ].x, '@' );
        }

        int in = getch();
        if( in == 'q' )
        {
            quit = 1;
        }
        for( i = 0; i < nJoeys; i++ )
        {
            move_actor( &oldJoey[ i ], rand() % 5 );
        }
    }

    erase();
    exit( endwin() );
    free( oldJoey );
    return 0;
}
